
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Native_app_checksDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const native_app_checks = await db.native_app_checks.create(
            {
                id: data.id || undefined,
        
        app_kind: data.app_kind
        ||
        null
            ,
            
        is_available: data.is_available
        ||
        false
        
            ,
            
        platform: data.platform
        ||
        null
            ,
            
        checked_at: data.checked_at
        ||
        null
            ,
            
        notes: data.notes
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await native_app_checks.setUser( data.user || null, {
            transaction,
        });
        
        await native_app_checks.setOrganizations( data.organizations || null, {
            transaction,
        });
        

        

        

        return native_app_checks;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const native_app_checksData = data.map((item, index) => ({
                id: item.id || undefined,
                
                app_kind: item.app_kind
            ||
            null
            ,
            
                is_available: item.is_available
            ||
            false
        
            ,
            
                platform: item.platform
            ||
            null
            ,
            
                checked_at: item.checked_at
            ||
            null
            ,
            
                notes: item.notes
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const native_app_checks = await db.native_app_checks.bulkCreate(native_app_checksData, { transaction });

        // For each item created, replace relation files
        

        return native_app_checks;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        const globalAccess = currentUser.app_role?.globalAccess;

        const native_app_checks = await db.native_app_checks.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.app_kind !== undefined) updatePayload.app_kind = data.app_kind;
        
        
        if (data.is_available !== undefined) updatePayload.is_available = data.is_available;
        
        
        if (data.platform !== undefined) updatePayload.platform = data.platform;
        
        
        if (data.checked_at !== undefined) updatePayload.checked_at = data.checked_at;
        
        
        if (data.notes !== undefined) updatePayload.notes = data.notes;
        
        
        updatePayload.updatedById = currentUser.id;

        await native_app_checks.update(updatePayload, {transaction});

        
        
        if (data.user !== undefined) {
            await native_app_checks.setUser(
              
              data.user,
              
              { transaction }
            );
        }
        
        if (data.organizations !== undefined) {
            await native_app_checks.setOrganizations(
              
              data.organizations,
              
              { transaction }
            );
        }
        

        
        

        

        return native_app_checks;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const native_app_checks = await db.native_app_checks.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of native_app_checks) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of native_app_checks) {
                await record.destroy({transaction});
            }
        });


        return native_app_checks;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const native_app_checks = await db.native_app_checks.findByPk(id, options);

        await native_app_checks.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await native_app_checks.destroy({
            transaction
        });

        return native_app_checks;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const native_app_checks = await db.native_app_checks.findOne(
            { where },
            { transaction },
        );

        if (!native_app_checks) {
            return native_app_checks;
        }

        const output = native_app_checks.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.user = await native_app_checks.getUser({
            transaction
        });
        
        
        output.organizations = await native_app_checks.getOrganizations({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           globalAccess,  options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        
        const user = (options && options.currentUser) || null;
        const userOrganizations = (user && user.organizations?.id) || null;
        

        
        if (userOrganizations) {
            if (options?.currentUser?.organizationsId) {
                where.organizationsId = options.currentUser.organizationsId;
            }
        }
        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.users,
        as: 'user',
        
        where: filter.user ? {
          [Op.or]: [
            { id: { [Op.in]: filter.user.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.user.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.organizations,
        as: 'organizations',
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.platform) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'native_app_checks',
                        'platform',
                        filter.platform,
                    ),
                };
            }
            
            if (filter.notes) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'native_app_checks',
                        'notes',
                        filter.notes,
                    ),
                };
            }
            

            
            

            
            if (filter.checked_atRange) {
                const [start, end] = filter.checked_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    checked_at: {
                    ...where.checked_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    checked_at: {
                    ...where.checked_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.app_kind) {
                where = {
                    ...where,
                app_kind: filter.app_kind,
            };
            }
            
            if (filter.is_available) {
                where = {
                    ...where,
                is_available: filter.is_available,
            };
            }
            


      

      
      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map(item => {
          return  Utils.uuid(item)
        });

        where = {
          ...where,
          organizationsId: {[Op.or]: listItems}
        };
      }
      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        
        if (globalAccess) {
            delete where.organizationsId;
        }
        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.native_app_checks.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset,  globalAccess, organizationId,) {
        let where = {};
        
        
        if (!globalAccess && organizationId) {
            where.organizationId = organizationId;
        }
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'native_app_checks',
                        'platform',
                        query,
                    ),
                ],
            };
        }

        const records = await db.native_app_checks.findAll({
            attributes: [ 'id', 'platform' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['platform', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.platform,
        }));
    }

    
};

